###This code is taken from StereoProject.py, and all references to two or more outputs are removed.
###If the code seems idiosyncronous at times, this may be caused by removed references to the two PJs instead of one

from opencv import *
from math import sin, cos, tan, pi
import os
import time
import datetime
import platform

###Creating global parameters
alpha = 1
beta = -1
mask =cvCreateImage(cvSize(1,1), 8, 3)
hiFPS=0
maxFPS=60
capture = cvCreateFileCapture( None )  
rotation=cvCreateMat(2,3,CV_32FC1)
matrix=cvCreateMat(3,3,CV_32FC1)

#####Updating image from Control Panel input

def update(pos):
        global matrix
        matrise=cvCreateMat(3,3,CV_32FC1)
        matrise=matrix
        
        ####Getting data from CP and performing calculations
        
        rotx=cvGetTrackbarPos("rotation x", "control panel")
        roty=cvGetTrackbarPos("rotation y", "control panel")
        size=cvGetTrackbarPos("size", "control panel")
        posx=cvGetTrackbarPos("position x", "control panel")
        posy=cvGetTrackbarPos("position y", "control panel")
        keysx=cvGetTrackbarPos("keystone x", "control panel")
        keysy=cvGetTrackbarPos("keystone y", "control panel")          
        rotx=((rotx-500)*pi)/1000
        roty=((roty-500)*pi)/1000
        size=((size-1000)*pi)/4000
                  
        ####Inserting new data in warp matrix
        
        matrise[1,0] =sin(rotx)
        matrise[0,1] =sin(roty)
        matrise[2,2]=1-(2*sin(size))
        matrise[0,2]=posx
        matrise[1,2]=posy
        matrise[2,0]=float(keysx-500)/250000
        matrise[2,1]=float(keysy-500)/250000
        matrix=matrise
       
###Updating horizontal and vertical flip

def flipping(pos):
        global matrix
        
        flip=cvGetTrackbarPos("flipping", "control panel")
        flipx=flip%2
        flipy=flip/2
        
        ###Updating warp matrix
        
        matrix[0,0]=(flipx*2)-1
        matrix[1,1]=-((flipy*2)-1)
         
###Updating rotation and masking of image
        
def maskAndRotate(pos):
        global mask
        global alpha
        global beta
        global rotation
        global capture
        
        ###Creating mask
        
        masks=os.listdir('./masks')
        mask_src = cvLoadImage("./masks/"+masks[cvGetTrackbarPos("mask", "control panel")])
        cvConvertImage( mask_src, mask_src, 1)
        cvResize(mask_src, mask, CV_INTER_AREA )
        
        ###Creating rotation matrix
        
        rotate=cvGetTrackbarPos("rotate", "control panel")
        cv2DRotationMatrix(cvPoint2D32f(mask.width/2, mask.height/2), 90*rotate, 1, rotation)
       
###Backing up parameters from Control Panel

def backup(man):
        handle = open("calibSingleLog.txt","a")
        logline = []
        
        ###Adding "Manual save" to differentiate between autosaves and manual backup
        
        if man:
                logline.append("Manual save:\n")
        
        ###writing all parameters to log file
        
        logline.append(str(cvGetTrackbarPos("flipping", "control panel")))
        logline.append(str(cvGetTrackbarPos("rotation x", "control panel")))
        logline.append(str(cvGetTrackbarPos("rotation y", "control panel")))
        logline.append(str(cvGetTrackbarPos("size", "control panel")))
        logline.append(str(cvGetTrackbarPos("keystone x", "control panel")))
        logline.append(str(cvGetTrackbarPos("keystone y", "control panel")))
        logline.append(str(cvGetTrackbarPos("position x", "control panel")))
        logline.append(str(cvGetTrackbarPos("position y", "control panel")))
        logline.append(str(cvGetTrackbarPos("mask", "control panel")))
        logline.append(str(cvGetTrackbarPos("rotate", "control panel")))

        
        handle.write((" ".join(logline))+"\n")
        handle.close()
        print "saved settings!"
      
###Loading either autosaves (1) or manual saves(0)

def load(autosaves):
        log = open("calibSingleLog.txt","r")
        txt= "1 500 500 1000 500 500 500 500"
        saved="Manual save:\n"
        if autosaves:
                for line in log:
                        txt=line
        else:
                next=0
                for line in log:
                    if next:
                        txt=line
                        next=0
                    if line == saved:
                        next=1                   
        log.close
        return txt
          
###Method used to replace a single value in a string, used to ease things in the calibration method
###Splits string into its individual pieces, replacing the value at the place indicated with the value given

def calibStringReplace(calibString, value, place):
        i=0
        ##finding numbers of values in the input string
        try:
        	while (1):
                        i+=1
                        str(calibString.split()[i])
                        if i>100:
                        	
                        	###used to detect and stop any infinite loops
                                print "overflow in stringReplace. Too long input string"
                                sys.exit(-1)
        except IndexError:
                i-=1        
        if int(place)>i:
                print "Attempted replace position does not exist!"
                print place
                print i
                return None
        endResult=""
        ii=0
        
        ###putting values back in place, up to the place that is to be replaced 
        while ii<int(place):
                endResult=endResult+(calibString.split()[ii])+" "
                ii+=1
                
        ###inserting wanted value at wanted position
        endResult=endResult+(value)+" "
        ii+=1
        
        ###Putting back rest of values
        while ii<=i:
                endResult=endResult+(calibString.split()[ii])+" "
                ii+=1
                
        return endResult
        
def calibrate(frame, frameName):
	
        cp="control panel"

        ###loading calibration images

        calibCorner_src = cvLoadImage( "calibration/Calib-corner.bmp" );
        calibCorner=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        cvResize(calibCorner_src, calibCorner, CV_INTER_AREA );
    
        calibCross_src = cvLoadImage( "calibration/Calib-cross.bmp" );
        calibCross=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        cvResize(calibCross_src, calibCross, CV_INTER_AREA );
    
        calibFull_src = cvLoadImage( "calibration/Calib-full.bmp" );
        calibFull=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        cvResize(calibFull_src, calibFull, CV_INTER_AREA );
    
        calibHorisont_src = cvLoadImage( "calibration/Calib-horizontal.bmp" );
        calibHorisont=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        cvResize(calibHorisont_src, calibHorisont, CV_INTER_AREA );
    
        calibVertical_src = cvLoadImage( "calibration/Calib-vertical.bmp" );
        calibVertical=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        cvResize(calibVertical_src, calibVertical, CV_INTER_AREA );
        
        calibEnd_src = cvLoadImage( "calibration/Calib-end.bmp" );
	calibEnd=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        cvResize(calibEnd_src, calibEnd, CV_INTER_AREA );
        
	###Actual calibration
	###Only the values that are relevant to a given test is possible to modify
	###These are saved before next step
	
        print "calibration will now commence:"
        i=0
        matrix
        params=load(1)
        while(i<5):
                if i<0:
                        print "already at beginning"
                        i=0
                if i==0:
                         print "adjust vertical keystone until lines are paralell"
                         src= calibVertical
                         i+=0.5
                         
                if i==0.5:
                         cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                         cvSetTrackbarPos("rotation x",  cp, int(params.split()[1]))
                         cvSetTrackbarPos("keystone x",  cp, int(params.split()[4]))
                         cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                         cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))   
                if i==1:
                        src= calibHorisont
                        params=calibStringReplace(params, str(cvGetTrackbarPos("rotation y", cp)), 2)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("size", cp)), 3)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("keystone y", cp)), 5)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("position x", cp)), 6)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("position y", cp)), 7)
                        print "adjust horizontal keystone until lines are paralell"
                        i+=0.5
                if i==1.5:
                        cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                        cvSetTrackbarPos("rotation y",  cp, int(params.split()[2]))
                        cvSetTrackbarPos("keystone y",  cp, int(params.split()[5]))
                        cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                        cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))
                if i==2:
                        src= calibCross
                        params=calibStringReplace(params, str(cvGetTrackbarPos("rotation x", cp)), 1)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("size", cp)), 3)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("keystone x", cp)), 4)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("position x", cp)), 6)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("position y", cp)), 7)
                        print "rotate until cross is aligned with plane"
                        i+=0.5
                if i==2.5:
                        cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                        cvSetTrackbarPos("size",  cp, int(params.split()[3]))
                        cvSetTrackbarPos("keystone x",  cp, int(params.split()[4]))
                        cvSetTrackbarPos("keystone y",  cp, int(params.split()[5]))
                        cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                        cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))
                if i==3:
                        src= calibFull
                        params=calibStringReplace(params, str(cvGetTrackbarPos("rotation x", cp)), 1)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("rotation y", cp)), 2)
                        print "adjust size until proper fit"
                        i+=0.5
                if i==3.5:
                        cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                        cvSetTrackbarPos("rotation x",  cp, int(params.split()[1]))
                        cvSetTrackbarPos("rotation y",  cp, int(params.split()[2]))
                        cvSetTrackbarPos("keystone x",  cp, int(params.split()[4]))
                        cvSetTrackbarPos("keystone y",  cp, int(params.split()[5]))
                        cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                        cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))
                if i==4:
                        src= calibCorner
                        params=calibStringReplace(params, str(cvGetTrackbarPos("rotation x", cp)), 1)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("rotation y", cp)), 2)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("size", cp)), 3)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("position x", cp)), 6)
                        params=calibStringReplace(params, str(cvGetTrackbarPos("position y", cp)), 7)
                        print "place in upper left corner"
                        i+=0.5
                if i==4.5:
                        cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                        cvSetTrackbarPos("rotation x",  cp, int(params.split()[1]))
                        cvSetTrackbarPos("rotation y",  cp, int(params.split()[2]))
                        cvSetTrackbarPos("size",  cp, int(params.split()[3]))
                        cvSetTrackbarPos("keystone x",  cp, int(params.split()[4]))
                        cvSetTrackbarPos("keystone y",  cp, int(params.split()[5]))
                        cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                        cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))
                        
                dst = cv.cvCreateImage (cv.cvSize (frame.width*2, frame.height*2), 8, 3)
                cvWarpPerspective( src,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
                
                cvShowImage(frameName, dst );

                ###Finding actions to perform for key input
                
                keyPressed=cvWaitKey(10)
                if keyPressed!=-1:
                	###Mpvement of image
                        if keyPressed==102:
                                flip=cvGetTrackbarPos("flipping", cp)
                                flip=(flip+1)%4
                                cvSetTrackbarPos("flipping", cp, flip)
                        elif keyPressed==100:
                                posx=cvGetTrackbarPos("position x", cp)
                                posx+=1
                                cvSetTrackbarPos("position x", cp, posx)
                        elif keyPressed==97:
                                posx=cvGetTrackbarPos("position x", cp)
                                posx-=1
                                cvSetTrackbarPos("position x", cp, posx)
                        elif keyPressed==119:
                                posy=cvGetTrackbarPos("position y", cp)
                                posy-=1
                                cvSetTrackbarPos("position y", cp, posy)
                        elif keyPressed==115:
                                posy=cvGetTrackbarPos("position y", cp)
                                posy+=1
                                cvSetTrackbarPos("position y", cp, posy)
                        elif keyPressed==43:
                                size=cvGetTrackbarPos("size", cp)
                                size+=1
                                cvSetTrackbarPos("size", cp, size)
                        elif keyPressed==45:
                                size=cvGetTrackbarPos("size", cp)
                                size-=1
                                cvSetTrackbarPos("size", cp, size)                      
                        elif keyPressed==65:
                                roty=cvGetTrackbarPos("rotation y", cp)
                                roty-=1
                                cvSetTrackbarPos("rotation y", cp, roty)
                        elif keyPressed==68:
                                roty=cvGetTrackbarPos("rotation y", cp)
                                roty+=1
                                cvSetTrackbarPos("rotation y", cp, roty)
                        elif keyPressed==83:
                                rotx=cvGetTrackbarPos("rotation x", cp)
                                rotx+=1
                                cvSetTrackbarPos("rotation x", cp, rotx)
                        elif keyPressed==87:
                                rotx=cvGetTrackbarPos("rotation x", cp)
                                rotx-=1
                                cvSetTrackbarPos("rotation x", cp, rotx)
                        elif keyPressed==101:
                                keysx=cvGetTrackbarPos("keystone x", cp)
                                keysx-=1
                                cvSetTrackbarPos("keystone x", cp, keysx)
                        elif keyPressed==113:
                                keysx=cvGetTrackbarPos("keystone x", cp)
                                keysx+=1
                                cvSetTrackbarPos("keystone x", cp, keysx)
                        elif keyPressed==122:
                                keysy=cvGetTrackbarPos("keystone y", cp)
                                keysy+=1
                                cvSetTrackbarPos("keystone y", cp, keysy)
                        elif keyPressed==99:
                                keysy=cvGetTrackbarPos("keystone y", cp)
                                keysy-=1
                                cvSetTrackbarPos("keystone y", cp, keysy)
                                
                        ###Backup current settings
                        elif keyPressed==19:
                                backup(1)
                                
                        ###Printing current tranformation matrix
                        elif keyPressed==112:
			        it1=0
				it2=0
				print "Transformation matrix for output"
				for it1 in range (0,3):
					for it2 in range (0,3):
						print "["+str(it1)+", "+str(it2)+"] "+str(matrix[it1, it2] )     	
			       		print ""           	
                        
                        ###Next calibration step
                        elif keyPressed==32:
                                i+=0.5
                        
                        ###Jump back one calibration step
                        elif keyPressed==2:
                                i-=1.5
                                params=calibStringReplace(params, str(cvGetTrackbarPos("rotation x", cp)), 1)
				params=calibStringReplace(params, str(cvGetTrackbarPos("rotation y", cp)), 2)
				params=calibStringReplace(params, str(cvGetTrackbarPos("size", cp)), 3)
				params=calibStringReplace(params, str(cvGetTrackbarPos("keystone x", cp)), 4)
				params=calibStringReplace(params, str(cvGetTrackbarPos("keystone y", cp)), 5)
				params=calibStringReplace(params, str(cvGetTrackbarPos("position x", cp)), 6)
                        	params=calibStringReplace(params, str(cvGetTrackbarPos("position y", cp)), 7)
                        
                        ###Escaping rest of calibration
                        elif keyPressed==27:
                                print "skipping rest of calibration"
                                i=5
                        
                        ###Loading a previously manual saved setting
                        elif keyPressed==12:
                                params=load(0)
                                cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                                cvSetTrackbarPos("rotation x",  cp, int(params.split()[1]))
                                cvSetTrackbarPos("rotation y",  cp, int(params.split()[2]))
                                cvSetTrackbarPos("size",  cp, int(params.split()[3]))
                                cvSetTrackbarPos("keystone x",  cp, int(params.split()[4]))
                                cvSetTrackbarPos("keystone y",  cp, int(params.split()[5]))
                                cvSetTrackbarPos("position x",  cp, int(params.split()[6]))
                                cvSetTrackbarPos("position y",  cp, int(params.split()[7]))
                                cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                                cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))
                        
                        ###Loading last saved setting (autosave)
                        elif keyPressed==76:
                                params=load(1)
                                cvSetTrackbarPos("flipping",  cp, int(params.split()[0]) )
                                cvSetTrackbarPos("rotation x",  cp, int(params.split()[1]))
                                cvSetTrackbarPos("rotation y",  cp, int(params.split()[2]))
                                cvSetTrackbarPos("size",  cp, int(params.split()[3]))
                                cvSetTrackbarPos("keystone x",  cp, int(params.split()[4]))
                                cvSetTrackbarPos("keystone y",  cp, int(params.split()[5]))
                                cvSetTrackbarPos("position x",  cp, int(params.split()[6]))
                                cvSetTrackbarPos("position y",  cp, int(params.split()[7]))
                                cvSetTrackbarPos("mask",  cp, int(params.split()[8]))
                                cvSetTrackbarPos("rotate",  cp, int(params.split()[9]))
                                        
                        ###for debug purposes
                        else:
                                print keyPressed
        print "Calibration complete \n"
        backup(0)
        
        ###using a reference image on the screen that is not used
	src=calibEnd
	dst = cv.cvCreateImage (cv.cvSize (frame.width*2, frame.height*2), 8, 3)
	cvWarpPerspective( src,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )

        cvShowImage(frameName, dst )
        
###Determining action for a key input

def keys(keyPressed):
        
        ###Movement of image
        if keyPressed==102:
                flip=cvGetTrackbarPos("flipping", "control panel")
                flip=(flip+1)%4
                cvSetTrackbarPos("flipping", "control panel", flip)
        elif keyPressed==100:
                posx=cvGetTrackbarPos("position x", "control panel")
                posx+=1
                cvSetTrackbarPos("position x", "control panel", posx)
        elif keyPressed==97:
                posx=cvGetTrackbarPos("position x", "control panel")
                posx-=1
                cvSetTrackbarPos("position x", "control panel", posx)  
        elif keyPressed==119:
                posy=cvGetTrackbarPos("position y", "control panel")
                posy-=1
                cvSetTrackbarPos("position y", "control panel", posy)
        elif keyPressed==115:
                posy=cvGetTrackbarPos("position y", "control panel")
                posy+=1
                cvSetTrackbarPos("position y", "control panel", posy)
        elif keyPressed==43:
                size=cvGetTrackbarPos("size", "control panel")
                size+=1
                cvSetTrackbarPos("size", "control panel", size)
        elif keyPressed==45:
                size=cvGetTrackbarPos("size", "control panel")
                size-=1
                cvSetTrackbarPos("size", "control panel", size)
        elif keyPressed==65:
	        roty=cvGetTrackbarPos("rotation y", "control panel")
	        roty-=1
	        cvSetTrackbarPos("rotation y", "control panel", roty)
	elif keyPressed==68:
	        roty=cvGetTrackbarPos("rotation y", "control panel")
	        roty+=1
	        cvSetTrackbarPos("rotation y", "control panel", roty)
	elif keyPressed==83:
	        rotx=cvGetTrackbarPos("rotation x", "control panel")
	        rotx+=1
	        cvSetTrackbarPos("rotation x", "control panel", rotx)
	elif keyPressed==87:
	        rotx=cvGetTrackbarPos("rotation x", "control panel")
	        rotx-=1
       		cvSetTrackbarPos("rotation x", "control panel", rotx)
        elif keyPressed==101:
	        keysx=cvGetTrackbarPos("keystone x", "control panel")
                keysx-=1
                cvSetTrackbarPos("keystone x", "control panel", keysx)
        elif keyPressed==113:
                keysx=cvGetTrackbarPos("keystone x", "control panel")
                keysx+=1
                cvSetTrackbarPos("keystone x", "control panel", keysx)
        elif keyPressed==122:
                keysy=cvGetTrackbarPos("keystone y", "control panel")
                keysy+=1
                cvSetTrackbarPos("keystone y", "control panel", keysy)
        elif keyPressed==99:
                keysy=cvGetTrackbarPos("keystone y", "control panel")
                keysy-=1
                cvSetTrackbarPos("keystone y", "control panel", keysy)
       		
        ###Resetting image to default
        elif keyPressed==114:
                backup(0)
                print "resetting"
                cvSetTrackbarPos("flipping",  "control panel", 1 )
                cvSetTrackbarPos("rotation x",  "control panel", 500)
                cvSetTrackbarPos("rotation y",  "control panel", 500)
                cvSetTrackbarPos("size",  "control panel", 1000)
                cvSetTrackbarPos("keystone x",  "control panel", 500)
                cvSetTrackbarPos("keystone y",  "control panel", 500)
                cvSetTrackbarPos("position x",  "control panel", 200)
                cvSetTrackbarPos("position y",  "control panel", 200)
                cvSetTrackbarPos("mask",  "control panel", 0)
                cvSetTrackbarPos("rotate",  "control panel", 0)

        ###Saving image parameters
        elif keyPressed==19:
                backup(1)
                
        ###Exiting and autosaving
        elif keyPressed==32:
                backup(0)
                return -1
        ###Exit without autosaving (escape)
        elif keyPressed==27:
                return -1
        
        ###Recalibrating active frame
        elif keyPressed==67:
        	backup(0)
                print "Recalibrating active frame"
                frame = cvQueryFrame( capture )
		calibEnd_src = cvLoadImage( "calibration/Calib-end.bmp" )
		calibEnd=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        	cvResize(calibEnd_src, calibEnd, CV_INTER_AREA )
        	
                calibrate(frame, "output")
                
        ###Putting up a calibration image other instances of this program could be calibrated after
        elif keyPressed==2:
                global matrix

		print "Calibration image, press the 'ANY' key to continue"
		frame = cvQueryFrame( capture )
        	calibEnd_src = cvLoadImage( "calibration/Calib-end.bmp" )
		calibEnd=cvCreateImage(cvSize(frame.width,frame.height), 8, 3)
        	cvResize(calibEnd_src, calibEnd, CV_INTER_AREA )
		src=calibEnd
		dst = cv.cvCreateImage (cvSize (frame.width*2, frame.height*2), 8, 3)
        	cvWarpPerspective( src,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		while (cvWaitKey(10)==-1):
        		cvShowImage("output", dst )

        ###print transformation matrix
        elif keyPressed==112:
	        it1=0
		it2=0
		for it1 in range (0,3):
			for it2 in range (0,3):
				print "["+str(it1)+", "+str(it2)+"] "+str(matrix[it1, it2] ) 	        	
	       		print ""    	
		     
        ###Loading a previously manual saved setting
        elif keyPressed==12:
                params=load(0)
                cvSetTrackbarPos("flipping",  "control panel", int(params.split()[0]) )
                cvSetTrackbarPos("rotation x",  "control panel", int(params.split()[1]))
                cvSetTrackbarPos("rotation y",  "control panel", int(params.split()[2]))
                cvSetTrackbarPos("size",  "control panel", int(params.split()[3]))
                cvSetTrackbarPos("keystone x",  "control panel", int(params.split()[4]))
                cvSetTrackbarPos("keystone y",  "control panel", int(params.split()[5]))
                cvSetTrackbarPos("position x",  "control panel", int(params.split()[6]))
                cvSetTrackbarPos("position y",  "control panel", int(params.split()[7]))
                cvSetTrackbarPos("mask",  "control panel", int(params.split()[8]))
                cvSetTrackbarPos("rotate",  "control panel", int(params.split()[9]))
        
        ###Loading last saved setting (autosave)
        elif keyPressed==76:
                params=load(1)
                cvSetTrackbarPos("flipping",  "control panel", int(params.split()[0]) )
                cvSetTrackbarPos("rotation x",  "control panel", int(params.split()[1]))
                cvSetTrackbarPos("rotation y",  "control panel", int(params.split()[2]))
                cvSetTrackbarPos("size",  "control panel", int(params.split()[3]))
                cvSetTrackbarPos("keystone x",  "control panel", int(params.split()[4]))
                cvSetTrackbarPos("keystone y",  "control panel", int(params.split()[5]))
                cvSetTrackbarPos("position x",  "control panel", int(params.split()[6]))
                cvSetTrackbarPos("position y",  "control panel", int(params.split()[7]))
                cvSetTrackbarPos("mask",  "control panel", int(params.split()[8]))
                cvSetTrackbarPos("rotate",  "control panel", int(params.split()[9]))
        
        ###Pausing the video
	elif keyPressed==16:
        	print "pause, press any key to continue"
        	capture
        	masking=cvGetTrackbarPos("mask", "control panel")
    	    	rotate=cvGetTrackbarPos("rotate", "control panel")
    	    	
    	    	frame = cvQueryFrame( capture )
    	    	
    	    	maskedFrame=cvCreateImage(cvSize(frame.width,frame.height), 8,3)
		rotframe=cvCreateImage(cvSize(frame.width*2,frame.height*2), 8,3)
		dst = cvCreateImage (cvSize (frame.width*2, frame.height*2), 8, 3)
    		
    		cvAddWeighted(frame, alpha, mask, beta, 0.0, maskedFrame)	
		cvWarpAffine( maskedFrame, rotframe, rotation,CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS,cvScalarAll(0) )		
		cvWarpPerspective( rotframe,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
		cvShowImage("output", dst )
		
		###Detect if keys have been pressed
		keyPressed=cvWaitKey(10)
		while(keyPressed==-1):  
			keyPressed=cvWaitKey(10)
                                          
        ###For debug operations
        else:
                print keyPressed
                
###Video loop for low framerate performance.
           
def videoLoop(framecount, framesincelast, lastcount, FPS, frame):

    ###Loading global parameters
    matrix
    alpha
    beta
    mask
    global hiFPS
    global maxFPS
    global capture
    
    ###creating empty images with size according to source
    ###Used for masks, rotations and destination images
    maskedFrame=cvCreateImage(cvSize(frame.width,frame.height), 8,3)
    rotframe=cvCreateImage(cvSize(frame.width*2,frame.height*2), 8,3)
    dst = cvCreateImage (cv.cvSize (frame.width*2, frame.height*2), 8, 3)
    
    ###The loop itself
    while True:
    	framecount+=1
        
        ###Grabbing frames from source video
        frame = cvQueryFrame( capture )
        if not frame:
        
            ###Reloading source if no frames are available
            capture = cvCreateFileCapture( captureFile )  
            frame = cvQueryFrame( capture )

            if not frame:
        		
            	print "Error when looping video, exiting. . ."
        	break
        	
        ###showing image before transformations		
        cvShowImage("source material", frame)
        
        ###Getting mask and rotation parameters
        masking=cvGetTrackbarPos("mask", "control panel")
        rotate=cvGetTrackbarPos("rotate", "control panel")
       	
       	###Choosing correct steps, for performance only needed operations are performed
       	###Warping of source image will of course always be done.
       	
        ###If both masking and rotation operations are needed
        if masking!=0 and rotate!=0:
        
        	cvAddWeighted(frame, alpha, mask, beta, 0.0, maskedFrame)
        	
        	cvWarpAffine( maskedFrame, rotframe, rotation,CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS,cvScalarAll(0) )

        	cvWarpPerspective( rotframe,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )

        ###If only masking is needed
        elif masking!=0 and rotate==0:
        
        	cvAddWeighted(frame, alpha, mask, beta, 0.0, maskedFrame)
        	
        	cvWarpPerspective( maskedFrame,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
        ###If only rotation is needed
        elif  masking==0 and rotate!=0:
        
        	cvWarpAffine( frame, rotframe, rotation,CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS,cvScalarAll(0) )
		
        	cvWarpPerspective( rotframe,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
        ###If neither operations are needed
        elif  masking==0 and rotate==0:
        
        	cvWarpPerspective( frame,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
	###The loop cannot, under any normal cirumstance end here.
	else:
		dst=frame
	
        ###Detecting if keys are pressed
        keyPressed=cvWaitKey(100)
        if keyPressed!=-1:
                if keys(keyPressed)==-1:
                        sys.exit(0)
	
	###Crude FPS counter and statistics management
	thisframetime=time.ctime(time.time())
	if thisframetime==lastcount:	
		framesincelast+=1
	else:
		if framesincelast !=0:
			FPS.append(framesincelast)
		try:
			print str(framesincelast)+" current "+str(sum(FPS, 0.0)/len(FPS)) + " average fps, " + str(sum(FPS, 0))+ " total frames."
			
			###Jump to high speed loop if framerate is above threshold
			if framesincelast>maxFPS:
				print "FPS too high, entering monitor mode"
				hiFPS=1
				break
		except ZeroDivisionError:
			print "no FPS"
		framesincelast=0	
		lastcount=time.ctime(time.time())
	
        ###Displaying the warped images
        cvShowImage("output", dst )
        cvShowImage("output", dst )
   
        ###Detecting if keys are pressed
        keyPressed=cvWaitKey(100)
        if keyPressed!=-1:
                if keys(keyPressed)==-1:
                        sys.exit(0)

###Video loop with FPS controls for when performance is higher than needed

def videoFPSLoop(framecount, framesincelast, lastcount, FPS, frame):
	
	###Loading global parameters
	matrix
	alpha
	beta
	mask
        global hiFPS
        global maxFPS
        global capture
        
        ###Saving time for FPS control
	lastFrame = datetime.datetime.now()
        
        ###creating empty images with size according to source
    	###Used for masks, rotations and destination images
    	maskedFrame=cvCreateImage(cvSize(frame.width,frame.height), 8,3)
    	rotframe=cvCreateImage(cvSize(frame.width*2,frame.height*2), 8,3)
    	dst = cvCreateImage (cvSize (frame.width*2, frame.height*2), 8, 3)
    	
    	###The loop itself
    	while True:
    		framecount+=1
    	    
    	    	###Grabbing frames from source video
    	    	frame = cvQueryFrame( capture )
    	    	if not frame:
    	    
    	        	###Reloading source if no frames are available
    	        	capture = cvCreateFileCapture( captureFile )  
    	        	frame = cvQueryFrame( capture )
	
    	        if not frame:
    	    		
    	        	print "Error when looping video, exiting. . ."
    	    		break
    	    	
    	    	###showing image before transformations		
    	    	cvShowImage("source material", frame)
    	    
    	    	###Getting mask and rotation parameters
    	    	masking=cvGetTrackbarPos("mask", "control panel")
    	    	rotate=cvGetTrackbarPos("rotate", "control panel")
    	   	
    	    	###Choosing correct steps, for performance only needed operations are performed
    	    	###Warping of source image will of course always be done.
    	   	
    	    	###If both masking and rotation operations are needed
    	    	if masking!=0 and rotate!=0:
    	    	
    	    		cvAddWeighted(frame, alpha, mask, beta, 0.0, maskedFrame)
    	    	
    	   		cvWarpAffine( maskedFrame, rotframe, rotation,CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS,cvScalarAll(0) )
	
    	    		cvWarpPerspective( rotframe,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
	
    	    	###If only masking is needed
    	    	elif masking!=0 and rotate==0:
    	    	
    	    		cvAddWeighted(frame, alpha, mask, beta, 0.0, maskedFrame)
    	    	
        		cvWarpPerspective( maskedFrame,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
    	    	###If only rotation is needed
    	    	elif  masking==0 and rotate!=0:
    	    	
        		cvWarpAffine( frame, rotframe, rotation,CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS,cvScalarAll(0) )
		
        		cvWarpPerspective( rotframe,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
    	    	###If neither operations are needed
    	    	elif  masking==0 and rotate==0:
    	    	
        		cvWarpPerspective( frame,  dst, matrix, (CV_INTER_LINEAR+CV_WARP_FILL_OUTLIERS), cvScalarAll(0) )
		
	   	###The loop cannot, under any normal cirumstance end here.
	    	else:
	    		dst=frame
	    	
       	    	###Detecting if keys are pressed
	    	keyPressed=cvWaitKey(10)
	    	if keyPressed!=-1:
	    		if keys(keyPressed)==-1:
                		sys.exit(0)
		
	    	####Crude FPS counter, management and statistics		
	    	thisframetime=time.ctime(time.time())
	    	if thisframetime==lastcount:		
	    		framesincelast+=1
	    	else:
	    		if framesincelast !=0:
				FPS.append(framesincelast)
			try:			
				print str(framesincelast)+" current "+str(sum(FPS, 0.0)/len(FPS)) + " average fps, " + str(sum(FPS, 0.0))+ " total frames."
				
				###Jump to low speed loop if framerate is too low
				if  (framesincelast < (maxFPS/2) and framesincelast != 0):
					print "FPS below threshhold, entering non-monitor-mode"
					hiFPS=0
					break
			except ZeroDivisionError:
				print "no FPS"
			framesincelast=0
			lastcount=time.ctime(time.time())

		###Sleeping until it is time to display the frame
		time.sleep (max(float(((1./maxFPS)*1000000)-(datetime.datetime.now()-lastFrame).microseconds)/1000000, 0))
		lastFrame = datetime.datetime.now()
		
	    	###Displaying the warped frames
	    	cvShowImage("output", dst )

       	    	###Detecting if keys are pressed
	    	keyPressed=cvWaitKey(10)
	    	if keyPressed!=-1:
	    		if keys(keyPressed)==-1:
                		sys.exit(0)
###Main program start
if __name__ == "__main__":
    print str(platform.system())+" "+str(platform.release())+ " "+ str(sys.getwindowsversion())+" . . . "

    ###Getting global parameters
    matrix
    alpha
    beta
    mask
    hiFPS
    capture
    
    ###initializing capture
    capture = None       
    if len(sys.argv)==1:
        print "Capturing from webcam . . . "
        capture = cvCreateCameraCapture( 0 )

    ###Getting video source from input parameters
    elif len(sys.argv)==2:
        captureFile=sys.argv[1]

        print "Capturing from file, source path: "+captureFile+  ". . ."
        capture = cvCreateFileCapture( captureFile )  
    else:
        print "You must specify the path of a video file when launching this script or use a webcam"
        sys.exit(-1)
    
    ###If no capture media can be found
    if not capture:
    	print "Could not initialize capturing. . ."
        sys.exit(-1) 
       
    ###Grabbing frame for size measurement and check
    frame = cvQueryFrame( capture )

    ###counting number of masks in folder and resizing mask master to fit source
    num_masks=0
    mask2=cvCreateImage(cvSize(frame.width, frame.height), 8, 3)
    cvResize(mask, mask2, CV_INTER_AREA );
    mask=mask2     
    masks=os.listdir('./masks')
    for file in os.listdir('./masks'):
        num_masks+=1
    
    ###Creating Control Panel windows
    cvNamedWindow ("control panel")
    cvResizeWindow("control panel",300,500)
    
    ###Loading last used parameters
    params=load(1)
    
    ####Adding trackbars to Control Panels
    cvCreateTrackbar("rotation x",  "control panel", int(params.split()[1]), 1000, update)
    cvCreateTrackbar("rotation y",  "control panel", int(params.split()[2]), 1000, update)
    cvCreateTrackbar("size",  "control panel", int(params.split()[3]), 2000, update)
    cvCreateTrackbar("keystone x",  "control panel", int(params.split()[4]), 1000, update)
    cvCreateTrackbar("keystone y",  "control panel", int(params.split()[5]), 2000, update )
    cvCreateTrackbar("position x",  "control panel", int(params.split()[6]), 2000, update )
    cvCreateTrackbar("position y",  "control panel", int(params.split()[7]), 2000, update)
    cvCreateTrackbar("flipping",  "control panel", int(params.split()[0]), 3, flipping)
    cvCreateTrackbar("mask",  "control panel", int(params.split()[8]), num_masks-1, maskAndRotate)
    cvCreateTrackbar("rotate",  "control panel", int(params.split()[9]), 3, maskAndRotate)
    
    ###Updating all parameters to properly display image
    update(0)
    flipping(0)
    maskAndRotate(0)
    
    ###Creating output images
    cvNamedWindow( "output", 0)
    calibrate(frame, "output")
    
    cvNamedWindow ("source material")
    
    ###Initializing framerate counters and statistical material
    framecount=0
    framesincelast=0
    lastcount=0
    FPS=[]
    hiFPS=0
    
    ###Loop for jumping between high and low framerate loops
    while (1):
    	if hiFPS==1:
    		print "entering high FPS mode"
    		videoFPSLoop(framecount, framesincelast, lastcount, FPS, frame)
    	if hiFPS==0:
    		print "entering low FPS mode"
    		videoLoop(framecount, framesincelast, lastcount, FPS, frame)
                        
    ###Destroying all windows and cleaning up for closing of the program
    cvDestroyWindow("output")
    cvDestroyWindow("source material")
    cvDestroyWindow("control panel")

    cvWaitKey()